source get_vmsize.tcl

set count 5000000000
set print_interval 5000000
#set size_interval 5000000
#set size_interval 500

set start_time [ clock seconds ]

puts "Time,Size,VMSize"

set iteration_time $start_time

# This loop eventually crashes when it is no longer able to grow the array due to some 32 bit weirdness.
for { set i 0 } { $i < $count } { } {
    # This line, and the frequency at which it is called makes a huge difference in the slowdown.
    # The slowdown is caused because array size is an order 'n' operation in Tcl.  This is said
    # to be due to the need to account for magic that can be done with upvar etc. to make objects
    # that have a name in the array but do not exist.
    #if { (($i % $size_interval) == 0) || ($i % $print_interval == 0) } { 
    #    set sz [ array size ::all_nets ]
    #}

    if { $i % $print_interval == 0 } {
#        set sz [ array size ::all_nets ]
        puts "[ format "%d,%d,%d" [expr { [clock seconds] - $start_time } ] $i [ get_vmsize ] ] "
        #set iteration_time [ clock seconds ]
    }
    set ::all_nets("h$i") $i
    incr i
}
puts "Total:\n======" 
puts [ format "%7d %8d" [expr { [clock seconds] - $start_time } ] $sz]
puts "VMSize = [ get_vmsize ] "
