
package require Itcl

# File cleanup using an Itcl class
itcl::class file_handler {
  variable m_data
  constructor { filename } {
    set m_data [ open $filename "w" ]
  }
  destructor {
    puts "closing file $m_data"
    close $m_data
  }
  method get_file {} {
      return $m_data
  }
}

proc do_file_stuff {} {
    itcl::local file_handler f1 "foo.txt"
    set local_vars [ info vars "itcl-local*" ]
    puts "itcl-local variables: $local_vars"
    foreach var $local_vars {
        puts "Trace info for $var: [ trace info variable $var ]"
    }

    puts [f1 get_file] "hello_world"
    puts "open files during call to do_file_stuff:"
    puts [ chan names ]
}

proc run_example {} {
    puts "open files to start with:"
    puts [ chan names ]

    do_file_stuff

    puts "open files at the end:"
    puts [ chan names ]
}

run_example
itcl::local file_handler f2 "bar.txt"

