

#include <tcl.h>
#include <iostream>
#include <string>
#include <string.h>
#include <stdlib.h> 
#include <itcl.h>

using std::cout;
using std::endl;

static char randomChar()
{
  // ascii chars i want are numbered 48 through 90, 42 total range
  return (char)((rand() % 42) + 48);
}


static int testHashTables()
{
    printf("Test Hash Tables\n");

    Tcl_HashTable ht;
    Tcl_InitHashTable(&ht, TCL_STRING_KEYS);

    int isNew;
    unsigned int counter = 0;
    cout << "This will require about 100 GB of memory before it crashes... be aware ..." << endl;

    for (int i=0; i <= 0x30000000; i++) {
      char key[32];
      for (size_t j=0; j < (sizeof(key)-1); j++)
        key[j] = randomChar();
      key[31] = '\0';
      Tcl_CreateHashEntry(&ht, key, &isNew);
      if (isNew)
        counter++;

      if ((i % 0x300000) == 0 || ht.numEntries > 0x2ffffff8)
        printf("i == %10d, numEntries: %10d, rebuildSize: %10d 0x%08x, key: %s num unique: %10u\n",
               i, ht.numEntries, ht.rebuildSize, ht.rebuildSize, key, counter);
    }

    Tcl_DeleteHashTable(&ht);

    return TCL_OK;
}

int do_Foo(
    ClientData c_data,
    Tcl_Interp *interp,
    int argc,
    Tcl_Obj *     CONST argv[]
)
{
    testHashTables();
    return TCL_OK;
}

int Foo_Appinit( Tcl_Interp* interp ) {
    if ((Tcl_Init)(interp) == TCL_ERROR) {
	return TCL_ERROR;
    }

    Tcl_CreateObjCommand(interp, "do_foo", do_Foo, NULL, NULL);
    return TCL_OK;
}

int main( int argc, char* argv[] ) {

    Tcl_Main( argc, argv, &Foo_Appinit );

}
